/* Useful.h
Uploaded 13th Sept 1994
A collection of several subroutines I wrote are generally
useful. All of them work, though optimisation for your own program
is probably a good idea.

Author : Clive Galway (Compuserve id : 100416,1461)
	I am attempting to start a career as a programmer. Any jobs or info on
	job vacancies (I live in London, UK, but are willing to travel) would be
	greatly appreciated.
This code is freeware - use and abuse !
My only request is that you let me know what you think ! Any comments,
suggestions or improovements, please let me know.

The main functions are:
menu - accepts a filename from which to do a menu of. See file "menu.mnu" for
	an example. It returns the number of the selection made - VERY USEFUL !!!
normcol & invcol - The program I wrpte this for was mono, so these are set to
	black and white. These control whether the program is operating in NORMal
	or INVerse mode. Used so that a change to invcol and normcol changes
	colour throughout the program and so these values could be changed within
	the	program to change palette !
display_centered_text - Self explanitory really. You pass it the text, the y
	co-ordinate and the width (Included so that you can have a same size 'box'
	for different length texts.) and it displays it in the normal colour.
input-string - I wrote this subroutine in a blinding flash of inspiration <g>.
	It is a generic input routine far superior to gets or the like.
	The control fields are:
	mode - Defines the case and character screening.
		0 - Letters only. Converts all letters to lower case.
		1 - Letters only. 1st letter upper case, all others lower.
		2 - Letters only. Converts all letters to upper case.
		3 - Most printable characters
	letters - This is the maximum length of the string.
	inputstr - A pointer to where the data is to be stored
	line_length - Determines how long each line is to be. 0 means the text is
		all in one line. For example, if line_length is 10, entering "The quick
		brown fox jumped over the lazy dogs."  will look like this:
			The quick
			brown fox
			jumped ove
			r the lazy
			 dogs.
		Obviously, this is more useful for longer line lengths, but a line
		length of 1 makes entered text go vertically down.
		pressing <TAB> in a multi-lined input will move down to the next line
		and pad with all the spaces necesarry (Don't change this to pad with
		zero's - it would be very stupid !!! <g>)
	Notes on using input_string.
		- If the memory location you pass for input (i.e inputstr[] field)
			is not null (i.e there is already a string there), then
			input_string will edit what is there, and will display it at
			the current x and y co-ordinates.
		- input_string has various return codes : see the function itself for
			more info.
input_num - I wrote this bit of code to facilitate (nearly) idiot - proof
	number entry. The control fields are as follows:
	max - This is the largest integer part that can be entered. As the total
	is calculated as the number is built up, then any attempt to press a
	number that would result in an invalid number would cause the computer to
	beep. For example, if max was 500, then the following keypresses would
	have the following results:
		4	- ok, rt (running total) = 4
		1	- ok, rt = 41
		5	- ok, rt = 415
		0	- beep, rt = 415 (rt of 4150 would be invalid !)
		.	- o.k, rt = 415.0
		max will not stop .99999999999999 being entered, because it is not
		concerned with the decimal part, that is the job of:
	decimal_places - This variable dictates how many decimal places are to be
		allowed, A value of 0 indicates that no decimal places are allowed.
		This feature of the subroutine has been 'doctored' to modify all non
		zero decimal_places value to 2 (i.e. you can use 2dp or 0dp because of
		the way numbers are returned - see later.
	number - a pointer to a long int of where the number is stored. If this
		value is non - zero, then the number is edited a la input_string.
	Notes for using input_num:
		- Numbers are passed to and from input_num as long ints. The number's
			decimal point is moved to the left the number of places contained
			in decimal_places. This is why decimal_places has to be either 0
			or 2 : I haven't provided for conversion etc for those other bits
			yet.

enjoy !
*/
#ifndef _useful_h
#define _useful_h

#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <dos.h>
#include <stdlib.h>

int menu (char*);
double int_to_float (long int);
long int float_to_int (double);
void normcol(void);
void invcol(void);
void display_centered_text(char[],int,int);
void display_bottom_bar(char *);
void invert_menu_bar(int,int);
int input_string(int,int,char *,int);
int input_num(long int,int,long int *);
void beep(void);
void getxy(int*,int*);
//File IO functions:
int does_file_exist(char *);
int read_line(FILE*,char*);
void open_error(char[12]);
void close_error(char[12]);
void read_write_error(char[4],FILE*);
void exit_program(int);
FILE* open_file(char[12],char[1]);
void close_file(char[12],FILE*);



//=== Make a beep ============================================================
void beep (void)
	{
	sound (100);		// warning beep
	delay (100);
	nosound();
	}



//=== Get current x and y coordinates ========================================
void getxy (int *x, int*y)
	{
	*x=wherex();
	*y=wherey();
	}


//=== input number ===========================================================
//=================== Max specifies the highest value enterable (int part  ===
//=================== only)                                                ===
//===================                                                      ===
//=================== decimal_places specifies how many decimal places the ===
//=================== number is to run to.                                 ===
//===================                                                      ===
//=================== If max is 3 and digits are as follows then entering  ===
//=================== following values will return the following results:  ===
//===================                                                      ===
//============================================================================
//=================== ENTERED     D_P      RETURNED   ========================
//===================                                 ========================
//=================== 150.999      3        150999    ========================
//=================== 150.65       3        150650    ========================
//=================== 150.1        3        150100    ========================
//=================== 150          3        150000    ========================
//=================== 150.99       2        15099     ========================
//=================== 150          2        15000     ========================
//=================== 150          0        150       ========================
//===================                                 ========================
//============================================================================
//============================================================================
//===================== Return codes                        ==================
//=====================                                     ==================
//===================== 0 - all's well-value returned       ==================
//===================== 1 - CTRL-DELETE pressed-original    ==================
//=====================     returned- indicates restoration ==================
//=====================     of previous value               ==================
//===================== 2 - TAB pressed-inputted value      ==================
//=====================     returned                        ==================
//===================== 3 - END pressed inputted value      ==================
//=====================     returned                        ==================
//===================== 4 - ESCAPE pressed-indicates abort  ==================
//=====================     input of data with no save.     ==================
//=====================                                     ==================
//============================================================================
//============================================================================

int input_num(long int max,int decimal_places, long int *number)
	{
	int inputnum=0;         // ascii code of next character
	long int total=0;	// running total
	register int count=0;            // number of digits
	register int subcount;
	int xloc,yloc=0;
	int lastnum=0;		// so delete can modify total
	int float_count=0;	// number of decimal digits
	int return_code=0;	// used by tab & escape to let enter process exit display
	char conversion[15];

	if (!max) max=20000000;		// 0 in max means use default value
	if (decimal_places) decimal_places = 2;	// see following text...
	// The above line was included for future improvement to allow any
	// number of decimal points to be entered. ( The program I wrote this for
	// only used 22 dp ( Money ! )
	if (*number != 0)	// print current number
		{
		ltoa (*number,conversion,10);	// convert number to string for length evaluation
		count=strlen(conversion);	// calculate length
		lastnum=conversion[count];	// last number is last digit!
		subcount=count;			// subcount points to terminating \0
		if (decimal_places)
			{
			for (;( subcount >= (count-decimal_places));subcount--)	// scan through fraction part
				{
				conversion[subcount+1]=conversion[subcount];	// move character
				gotoxy(xloc,yloc);
				}
			conversion[count-decimal_places]='.';	// add decimal .
			}
		cprintf("%s",conversion);	// print string
		total=*number;			// stored in *number
//		getxy (&xloc,&yloc);		// move cursor to end of string
//		xloc++;				// allow for decimal .
//		gotoxy (xloc+count,yloc);
		if (decimal_places)
			{
			float_count=decimal_places+1;	// set up float indicators...
			count -= decimal_places;	// ... modify integer count.
			}

		}
	else			// if number is 0
		{
		count=0;
		total=0;
		lastnum=0;
		printf("0");
		}
	while(inputnum != 13)
		{

/*
		// Un-comment this for a useful debugging tool !
		getxy(&xloc,&yloc);
		gotoxy(10,20);
		cprintf("Total:%ld   Lastnum:%d  Count:%d Float count:%d ",total,lastnum,count,float_count);
		gotoxy(xloc,yloc);
*/

		fflush(stdin);
		_setcursortype(_SOLIDCURSOR);
		inputnum=getch();
		_setcursortype(_NOCURSOR);
		return_code=0;			// RESET RETURN CODE
		switch (inputnum)
			{
			case 0:			// EXTENDED KEYCODE pressed:
				{
				inputnum=getch();	// get extended keycode
				if (inputnum==79)	// END pressed
					{
					return_code=0;
					inputnum=13;
					}
				else inputnum=0;		// so no other if's are executed
				break;
				}
			case 127:		// CTRL-DELETE pressed
				{
				return_code=2;	// indicate display processing to be made
				inputnum=13;	// so entry terminates
				break;
				}
			case 27:			// ESCAPE pressed
				{
				return_code=1;	// indicates abort entry
				inputnum=13;
				break;
				}
			case 9:			// TAB pressed
				{
				return_code=3;		// indicate display processing may be required
				inputnum=13;		// so entry terminates
				break;
				}
			case 13:		// ENTER PRESSED
				{
				return_code=4;		// will drop through anyway, but needs return code
				break;
				}
			case 8:			// DELETE pressed
				{
				if(count != 0)
					{
					if (float_count)
						{
						float_count--;
						if (float_count==0)
							{
							cprintf("\b \b");
							}
						else
							{
							total-=lastnum;
							total/=10;
							cprintf("\b \b");
							lastnum=(total%10);
							}
						}
					else
						{
						total-=lastnum;
						total/=10;
						cprintf("\b \b");
						if (!total) cprintf("0");	// always leav 1 zero
						count--;
						lastnum=(total%10);
						}
					}
				else beep();
				break;
				}
//			default:		// key not recognised
//				{
//				inputnum=0;	// clear it so no confusion
//				}
			}


		if( (float_count <= decimal_places) && (inputnum > 47) && (inputnum < 58) )
			{
			if ( (float_count==0) && (((total * 10)+(inputnum - 48)) >max))
				{	// dont check num in float part
				beep();			// invalid addition !
				}
			else
				{
				lastnum=(inputnum-48);
				if (float_count) float_count++;
				if ((!float_count)&&(!total))	// if there is a zero to be overwritten
					{
					cprintf("\b \b");
					}
				count++;
				total*=10;        	// mltiply old value by 10...
				total+=(inputnum-48);	// ...and add new unit
				cprintf("%d",(inputnum-48));
				}

			}
		else if ( (inputnum==46) && (decimal_places) && (float_count==0) )	// decimal point
			{
			cprintf(".");
			float_count=1;
			}
		else if ( ! (return_code > 1 || inputnum == 8) )  // !!!!!!!
			{
			if (inputnum != 13) beep();	// invalid key
			}

		}
	// loop finishes here when inputnum is 13.



	if (return_code==2)		// CTRL-DELETE
		{
		getxy(&xloc,&yloc);	// first find cursor position
		if (count)	// as long as count is not 0
			{
			xloc -= count;
			}
		else xloc--;		// zero would be printed
		if (float_count)	// if the decimal point etc is displayed
			{
			xloc -= float_count;	// float count of 1 means just d.p. displayed
			}
		gotoxy(xloc,yloc);	// cursor is now at origin
		ltoa (max,conversion,10);	// get longest possible number in string (not inc d.p.)
		count=strlen(conversion);	// find it's length
		count++;			// allow for decimal .
		for (;count;count--)		// cycle count times
			{
			printf(" ");		// erase any numbers that could be present
			}
		for (;float_count;float_count--)// cycle float_count times
			{
			printf(" ");
			}
		gotoxy(xloc,yloc);	// cursor is now back at origin
		return(2);
		}


	else if (total)			// 0 is displayed "0" not "0.00"
		{
		if (decimal_places)	// could there be any d.p's ?
			{
			if (float_count==0)	// if decimal point isn't displayed
				{
				printf(".");	// display it
				float_count++;	// indicate this
				}
			for (;float_count<=decimal_places;float_count++)
				{	// add trailing zeros to pad out for decimal point
				total *= 10;
				printf ("0");	// modify displayed number
				}
			}
		}


	*number=total;		// put total in return variable
	return (return_code);
	}





//=== Input a string =========================================================
//===================== Input codes (mode field)            ==================
//=====================                                     ==================
//===================== 0 - all lower case                  ==================
//===================== 1 - 1st char upper case, rest lower ==================
//===================== 2 - all upper case                  ==================
//===================== 3 - as typed (Alphabetic & Numeric) ==================
//============================================================================
//===================== line_length field forces a carriage ==================
//==================== return every x chars. 0 means ignore. =================
//============================================================================
//============================================================================
//===================== Return codes                        ==================
//=====================                                     ==================
//===================== 0 - all's well-value returned       ==================
//===================== 1 - CTRL-DELETE pressed-original    ==================
//=====================     returned- indicates restoration ==================
//=====================     of previous value               ==================
//===================== 2 - TAB pressed-inputted value      ==================
//=====================     returned                        ==================
//===================== 3 - END pressed inputted value      ==================
//=====================     returned                        ==================
//===================== 4 - ESCAPE pressed-indicates abort  ==================
//=====================     input of data with no save.     ==================
//=====================                                     ==================
//============================================================================
//============================================================================

int input_string(int mode,int letters,char inputstr[],int line_length)
	{
	int inputchar=0;
	int upper,lower;		// specifies case of current letter
	int count=0;
	int subcount=0;		// no of characters entered so far
	int check=0;
	int xstart,ystart;
	int xcoord,ycoord;
	char* backup;

	if(  (backup=(char *) malloc(sizeof (inputstr))) == NULL  )
		{
		beep();
		backup=inputstr;
		}
	strcpy(backup,inputstr);
//	count = strlen (inputstr);	// Enable editing of current contents of inputstr

	getxy (&xstart,&ystart);	// store start position
	cprintf("            ");
	gotoxy(xstart,ystart);
	count=0;
	while (inputstr[count])		// while not NULL
		{
		cprintf("%c",inputstr[count]);
		count++;
		if (count && line_length && (count != letters) ) if (count%line_length==0) gotoxy (xstart,ystart+(count/line_length));	// dont divide by zero !
		}
	subcount=count;
	getxy (&xcoord,&ycoord);	// save position of end of text;
	while (subcount<letters+1)	// fill with trailing spaces
		{
		cprintf(" ");
		subcount++;
		if (count && line_length && (count != letters) ) if (count%line_length==0) gotoxy (xstart,ystart+(count/line_length));	// dont divide by zero !
		}
	gotoxy (xcoord,ycoord);

	while(inputchar!=13)	// while not enter
		{
		fflush(stdin);

/*
		//Un-comment this for a useful debugging tool !
		getxy(&xcoord,&ycoord);
		gotoxy(70,1);
		cprintf("Count:%d ",count);
		gotoxy(xcoord,ycoord);
*/

		_setcursortype(_SOLIDCURSOR);	// Just because it looks nice !
		inputchar = getch();
		_setcursortype(_NOCURSOR);
		inputstr[count]=NULL;		// blank, just in case
		switch(inputchar)
			{
			case 0:     		// Extended key code ?
				{
				inputchar=getch();	// get exended keycode
				if (inputchar==79)	// END key
					{
					free (backup);
					return(0);
					}
				else inputchar=0;	// all other extended keycodes invalid
				}

			case 127:		// CTRL-DELETE
				{
				strcpy(inputstr,backup);
				free (backup);
				gotoxy(xstart,ystart);
				return(2);
				}
			case 27:		// ESCAPE
				{
				strcpy(inputstr,backup);
				free (backup);
				gotoxy(xstart,ystart);
				return(1);
				}

			case 9:			// Tab
				{		// only if it non-zero
				inputchar=0;		// make it drop through
				if (line_length !=0)
					{
					if ( ((count+line_length) >= letters) || count==0  )
						{	// dont jump to next line if last sector or beginning of 1st
						while(inputstr[count-1]==' ' && (count-1) ) //delete trailing spaces
							{
							inputstr[count-1]=NULL;
							count--;
							}
						free(backup);
						return(3);
						}
					else
						{			// blank line
						check=count/line_length;// check holds current line no (0 is 1st);
						check++;
						check*=line_length;	// check at start of new line
						for (;count<=check;count++)
							{
							inputstr[count]=' ';	// blank up until check
							cprintf(" ");
							}
						inputstr [count]=NULL;
						getxy(&xcoord,&ycoord);	// carriagge
						xcoord-=line_length;	// return
						ycoord++;		// and
						gotoxy(xcoord,ycoord);	// enter
						inputchar=1;	// stop beep
						}
					}
				else

					{
					while(inputstr[count-1]==' ' && (count-1) ) //delete trailing spaces
						{
						inputstr[count-1]=NULL;
						count--;
						}
					free(backup);
					return(3);
					}
				}

			case 8:		// delete
				{
				inputchar=1;		// stop beep
				if(count==0) beep();	// Cant delete past start !!!
				else
					{
					if (line_length)
						{
						if ( (count%line_length==0) && (count!=letters) )	// is delete across line ?
							{
							getxy(&xcoord,&ycoord);
							ycoord--;
							xcoord+=line_length;
							gotoxy(xcoord,ycoord);
							}
						}
					count--;
					inputstr[count]=NULL;	// delete char from string
					cprintf("\b \b");	// cursor left 1 space, write over, then back again.
					}
				}
			}




		//--- Analyse letter -----------------------------------------

		if(count!=(letters) && (inputchar>13) )	// last character must be delete, escape, or enter.
			{
			if( mode == 3 )	// allow any character except ENTER
				{
				inputstr[count]=inputchar;
				cprintf("%c",(inputchar));
				count++;
				}

			else if( (inputchar>64&&inputchar<91)||(inputchar>96&&inputchar<123) || inputchar==32)	// is it valid ?
				{
				if(inputchar>='A' && inputchar <='Z')
					{
					upper =1;
					lower =0;
					}
				else if (inputchar >='a' && inputchar <='z')
					{
					upper=0;
					lower=1;
					}
				else
					{
					upper=0;
					lower=0;
					}
				switch(mode)		// depending on the mode
					{
					case 0:		// all lower case
						{
						if (upper) inputchar+=32;	// convert to lower where needed
						break;
						}
					case 1:
						{
						if (count==0 && lower) inputchar-=32;	// Make 1st char uppercase only if mode =1
						if (count!=0 && upper) inputchar+=32;	// All subsequent caracters are lower case
						break;
						}
					case 2:
						{
						if (lower) inputchar -=32;		// make it upper case
						break;
						}
					case 3:
						{
						// do not modify.
						}
					}
				inputstr[count]=inputchar;	// write converted char
				cprintf("%c",(inputchar));
				count++;
				}
			inputchar=0;		// cause to drop through;
			}
		else if (inputchar !=13 && inputchar != 1)	// 1 means don't beep
			{
			beep();	// process char else beep
			}
		if (line_length)	// dont do otherwise divide by zero error
			{
			if ((count%line_length==0)&&(count != letters) && (!inputchar))
				{	// At start of newline, but not 1st or last line
				getxy(&xcoord,&ycoord);
				xcoord-=(line_length);
				ycoord++;
				gotoxy(xcoord,ycoord);
				}
			}
		}
	free (backup);			// free allocated memory
	return(4);		// must be ENTER
	}


//=== Display centered text ======================================================
void display_centered_text(char text[], int ypos, int width)
	{
	int count,xpos;
	char blank_bar[80]="";
	if( ((width/2)*2) != width) width ++;	// always an even number!
	for(count=0;count<(width+2);count++)
		blank_bar[count]=32;	//done so that all items are the same width
	blank_bar[count+1]=0;
	xpos=(((80-width) /2)+1);
	gotoxy((xpos-1),ypos);
	cprintf("%s",blank_bar);	// blanks out background in appropriate colour
	gotoxy(xpos,ypos);
	cprintf("%s",text);	// prints text
	}




//=== convert integer to 2 point dec. long float =============================
double int_to_float (long int i)
	{
	double ret_var;

	ret_var = (float) i;
	ret_var /= 100;
	return(ret_var);
	}

//=== convert long float to long int =========================================
long int float_to_int (double f)
	{
	long int ret_var;
	f *= 100;
	ret_var = (long int) f;
	return (ret_var);
	}



//=== Set normal colours ====================================================
void normcol()
	{
	textcolor(BLACK);			// Black text...
	textbackground(WHITE);		    	// ...on white background
	}

//=== Set inverse colours ====================================================
void invcol(void)
	{
	textcolor(WHITE);			// White text...
	textbackground(BLACK);			// ... on black background
	}



//=== Invert menu bar ========================================================
//=== inverts from white to black or black to white. If anyone knows a =======
//=== decent algorithm to determine the inverse of a particular colour =======
//=== then please e-mail me. =================================================
void invert_menu_bar(int row,int width)
	{
	char buffer[160];
	int left,right;
	int count;

	left=(39-(width/2));
	right=(left+(width*2));
	gettext(left,row,right,row,buffer);
	for(count=0;count<=(width*2);count++)
		{
		count++;
		if (buffer[count]==7) buffer[count]=112;
		else if (buffer[count]==112) buffer[count]=7;
		}
	puttext(left,row,right,row,buffer);
	}



//=== Menu routine ===========================================================
int menu (char *filename)
	{
	FILE *fp;
	char iostream[80];
	int menuitems=0;		// No. of items in menu.
	int menupos=1;			// position in menu
	int ypos=0;
	int selection=0;
	int longest=0;
	int keypress=0;

	fp=open_file(filename,"r");
	while(read_line(fp,iostream)!=EOF)	// count items in menu
		{
		if ((strlen(iostream) > longest))
			longest=strlen(iostream);	// which line is the longest ?
		if (*iostream != '\n') menuitems++;	// don't count blank lines.
		}

	if (menuitems) menuitems--;		// compensate for heading only if +ve
	close_file(filename,fp);
	ypos=(14-(menuitems/2));
	fp=open_file(filename,"r");
	read_line (fp,iostream);
	if (iostream[0] != '?')
		{
		display_centered_text(iostream,ypos-3,strlen(iostream));	// display title ?
		}
	while (read_line (fp,iostream)!=EOF)
		{
		display_centered_text(iostream,ypos,strlen(iostream));
		ypos++;
		}
	close_file(filename,fp);
	ypos=(13-(menuitems/2));	// set up ypos for offset calcs
	selection=0;
	while (!selection)
		{
		while (keypress != 13)	// menu moved or selection made
			{
			if (menupos > menuitems) menupos=1;
			if (menupos == 0 ) menupos = menuitems;
			invert_menu_bar(ypos+menupos,longest);
			keypress=getch();
			invert_menu_bar(ypos+menupos,longest);
			if (keypress==0)
				{
				keypress=getch();
				if (keypress==72) menupos--;		// up
				else if (keypress==80) menupos++;        	// down
				else return(keypress+1000);		// return keycode
				}
			if (keypress==27) return(0);		// escape
			}
		selection=menupos;
		}
	return(menupos);
	}
//=== Display info/ input bar ================================================
void display_bottom_bar(char *bar_text)
	{
	int x,y;
	char buffer[350];

	register int count;
	gotoxy(1,25);			// Go to bottom left of screen...

	for (count=0;bar_text[count];count++)	// while not NULL
		{
		if (bar_text[count]=='\n')
			{
			clreol();        	// enable multi-line
			gettext(1,25,80,25,buffer);
			puttext(1,24,80,24,buffer);
			gotoxy(1,25);
			}
		else
			{
			cprintf("%c",bar_text[count]);		// print the text...
			}
		}
	x=wherex();			// Store...
	y=wherey();			// ..position
	clreol();			// ...then clear the rest of line
	gotoxy(x,y); 			//positions cursor ready for input/output if needed
	}



// File IO functions


//=== Error opening file =====================================================
void open_error(char filename[12])
	{
	char bar_text[79]="";			// Text at bottom of screen
//	invcol();
	_setcursortype(_NOCURSOR);
	strset(bar_text,NULL);				// Clear bar_text...
	sprintf(bar_text,"Error opening file: %s",filename);            // ...Set up prompt...
//	display_bottom_bar(bar_text);			// ...then display it
	exit_program(9);
	}


//=== Error closing file =====================================================
void close_error(char filename[12])
	{
	char bar_text[79]="";			// Text at bottom of screen
//	invcol();
	_setcursortype(_NOCURSOR);
	strset(bar_text,NULL);				// Clear bar_text...
	sprintf(bar_text,"Error closing file: %s, press any key to exit...",filename);            // ...Set up prompt...
//	display_bottom_bar(bar_text);			// ...then display it
	if(!getch()) getch();                 // In case of extended key-code
	exit_program(2);
	}

//=== Error reading/writing record ===========================================
void read_write_error(char mode[4],FILE *fp)
	{
	char bar_text[79]="";			// Text at bottom of screen
//	normcol();
	clrscr();
//	invcol();
	_setcursortype(_NOCURSOR);
	strset(bar_text,NULL);				// Clear bar_text...
	sprintf(bar_text,"Error %sing file. Press a key...",mode);// ... text for bar ...
//	display_bottom_bar(bar_text);			// ...then display it
	if(!getch()) getch();                 // In case of extended key-code
	if(fclose(fp)==EOF)
		{
		strset(bar_text,NULL);				// Clear bar_text...
		strcat(bar_text,"Press any key to terminate program...");// ... text for bar ...
//		display_bottom_bar(bar_text);			// ...then display it
		if(!getch()) getch();                 // In case of extended key-code
		exit_program(3);
		}
	strset(bar_text,NULL);				// Clear bar_text...
	strcat(bar_text,"But I managed to close it ok. Press a key...");// ... text for bar ...
//	display_bottom_bar(bar_text);
	fflush(stdin);
	if(!getch()) getch();                 // In case of extended key-code
	}




//=== Close file =============================================================
void close_file(char filename[12],FILE*fp)
	{
	if(fclose(fp)==EOF) close_error(filename);
	}



//=== Open file for reading/writing ==========================================
FILE* open_file(char filename[12],char status[1])
	{
	FILE*fp;
	fp=fopen(filename,status);
	if(fp==NULL)
		{
		open_error(filename);
		}
	return(fp);	// returns address of file stream
	}


//=== Exit program cleanly ===================================================
void exit_program(int errorlevel)
	{
	_setcursortype(_NORMALCURSOR);
	system("cls");
	cprintf("Abnormal program termination: Error code %d\n",errorlevel);
	exit(errorlevel);
	}


//=== Read a line ============================================================
int read_line(FILE*fp,char *iostream)
	{
	if((fgets(iostream,80,fp))==NULL) return(EOF);
	return(0);
	}


//=== Does this file exist ? =================================================
int does_file_exist(char *filename)
	{
	struct find_t ffblk;
	int found=0;

	found = _dos_findfirst(filename,_A_NORMAL,&ffblk);
	return (!found);
	}

#endif